// $Id: terminal.lsl,v 1.6 2009/03/02 02:37:04 ssm2017binder Exp $
// @version SlUser
// @package Terminal
// @copyright Copyright wene / ssm2017 Binder (C) 2009. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

// **********************
//      USER PREFS
// **********************
// url ex: string url = "http://test.com";
string url = "";
// password
string password = "0000";
// infos
integer display_info = 0;
// update speed
integer update_speed = 60;
// busy time
integer busy_time = 30;
// **********************
//  DRUPAL VERSION URL
// **********************
string url2 = "/secondlife";
// **********************
//              STRINGS
// **********************
// === common ===
string _RESET = "Reset";
string _CLOSE = "Close";
string _MENU_TIMEOUT = "Menu time-out. Please try again.";
string _CHOOSE_AN_OPTION = "Choose an option";
string _SCRIPT_WILL_STOP = "The script will stop";
string _ENTERING_WAIT_MODE = "Entering wait mode";
// === user ===
string _REGISTER = "Register";
string _ONLY_ONE_USER_AT_A_TIME = "Only one user can use the terminal at a time";
string _ONLY_ONE_REQUEST_AT_A_TIME = "Only one request can be done at a time";
// === terminal ===
string _TERMINAL_INIT = "Terminal initialisation";
string _REGISTERING_THE_TERMINAL = "Registering the terminal";
string _UPDATING_THE_TERMINAL = "Updating the terminal";
// === terminal status ===
string _TERMINAL_IS_DISABLED = "Terminal is disabled";
string _TERMINAL_IS_ENABLED = "Terminal is enabled";
string _TERMINAL_IS_BUSY = "Terminal is busy";
// === http ===
string _REQUEST_TIMED_OUT = "Request timed out";
string _FORBIDEN_ACCESS = "Forbiden access";
string _PAGE_NOT_FOUND = "Page not found";
string _INTERNET_EXPLODED = "the internet exploded!!";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//      VARS
// **********************
key owner;
string owner_name;
key rpc_channel;
integer update_time;
integer act_time;
integer countdown = FALSE;
// user
integer request_time;
integer busy = FALSE;
key actual_user = NULL_KEY;
// separators
string HTTP_SEPARATOR = ";";
string PARAM_SEPARATOR = "||";
// **********************
//      CONSTANTS
// **********************
integer RESET = 20000;
integer ADD_APP = 20001;
integer ENABLE_COUNTDOWN = 20002;
// status
integer SET_READY = 20011;
integer SET_ENABLED = 20012;
integer SET_DISABLED = 20013;
integer SET_BUSY = 20014;
// params
integer SET_PARAMS = 20025;
integer GET_PARAMS = 20026;
// user
integer SET_ACTUAL_USER = 20101;
integer GET_ACTUAL_USER = 20102;
// **********************
//      CALL THE MENU
// **********************
list apps_menu = [];
callMainMenu(key dest, string question, list choice) {
    list menu;
    menu = apps_menu;
    if (llGetListLength(choice) > 0) {
        menu = choice;
    }
    dialog(dest, question+" : ", menu, menu);
}
// ************************************
//      GIVE VALUES TO OTHER SCRIPT
// ************************************
giveParams() {
    // url | url2 | password | display_info | update_speed | busy_time | http_separator
    string params = url+PARAM_SEPARATOR+url2+PARAM_SEPARATOR+password+PARAM_SEPARATOR+(string)display_info+PARAM_SEPARATOR+(string)update_speed+PARAM_SEPARATOR+(string)busy_time+PARAM_SEPARATOR+HTTP_SEPARATOR;
    llMessageLinked(LINK_THIS, SET_PARAMS, params, NULL_KEY);
}
// **************************
//      SET MESSSAGE
// **************************
setMessage(integer status) {
    string message = "";
    if (status == SET_ENABLED) {
        busy = FALSE;
        message = _TERMINAL_IS_ENABLED;
    }
    else if (status == SET_DISABLED) {
        message = _TERMINAL_IS_DISABLED;
    }
    else if (status == SET_BUSY) {
        busy = TRUE;
        message = _TERMINAL_IS_BUSY;
    }
    llSetText(message, <0.,1.,0.>, 1.);
}
// **********************
//          HTTP
// **********************
// register terminal
key registerTerminalId;
registerTerminal() {
    if (display_info) {
        llOwnerSay(_REGISTERING_THE_TERMINAL);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    registerTerminalId = llHTTPRequest(url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=sluser"
                        +"&cmd=registerTerminal"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass);
}
// update terminal
key updateTerminalId;
updateTerminal() {
    if (display_info) {
        llOwnerSay(_UPDATING_THE_TERMINAL);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    updateTerminalId = llHTTPRequest(url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=sluser"
                        +"&cmd=updateTerminal"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // terminal values
                        +"rpc_channel="+(string)rpc_channel);
}
// ********** DIALOG FUNCTIONS **********
// Dialog constants
integer lnkDialog = 14001;
integer lnkDialogNotify = 14004;
integer lnkDialogResponse = 14002;
integer lnkDialogTimeOut = 14003;
integer lnkDialogReshow = 14011;
integer lnkDialogCancel = 14012;
string seperator = "||";
integer dialogTimeOut = 0;
string packDialogMessage(string message, list buttons, list returns){
    string packed_message = message + seperator + (string)dialogTimeOut;
    integer i;
    integer count = llGetListLength(buttons);
    for(i=0; i<count; i++){
        string button = llList2String(buttons, i);
        if(llStringLength(button) > 24) button = llGetSubString(button, 0, 23);
        packed_message += seperator + button + seperator + llList2String(returns, i);
    }
    return packed_message;
}
dialogReshow(){llMessageLinked(LINK_THIS, lnkDialogReshow, "", NULL_KEY);}
dialogCancel(){
    llMessageLinked(LINK_THIS, lnkDialogCancel, "", NULL_KEY);
    llSleep(1);
}
dialog(key id, string message, list buttons, list returns){
    llMessageLinked(LINK_THIS, lnkDialog, packDialogMessage(message, buttons, returns), id);
}
dialogNotify(key id, string message){
    list rows;
    llMessageLinked(LINK_THIS, lnkDialogNotify,
        message + seperator + (string)dialogTimeOut + seperator,
        id);
}
// ********** END DIALOG FUNCTIONS **********
// ************************
//    CHECK REGISTRATION
// ************************
default {
    on_rez(integer nbr) {
        llResetScript();
    }
    state_entry() {
        llOwnerSay(_TERMINAL_INIT);
        // setup vars
        owner = llGetOwner();
        owner_name = llKey2Name(owner);
        // set message
        setMessage(SET_DISABLED);
    }
    touch_start(integer total_number) {
        if (llDetectedKey(0) == owner) {
            dialog(owner, _CHOOSE_AN_OPTION, [_REGISTER, _RESET, _CLOSE], [_REGISTER, _RESET, _CLOSE]);
        }
    }
    link_message(integer sender_num, integer num, string str, key id) {
        if (num == lnkDialogTimeOut) {
            dialogNotify(id, _MENU_TIMEOUT);
            state default;
        }
        else if (num == lnkDialogResponse) {
            if (str == _RESET) {
                llResetScript();
            }
            else if (str == _REGISTER) {
                registerTerminal();
            }
        }
    }
    http_response(key request_id, integer status, list metadata, string body) {
        if (request_id != registerTerminalId) {
            return;
        }
        if (status == 499) {
            llOwnerSay(_REQUEST_TIMED_OUT);
        }
        else if (status == 403) {
            llOwnerSay(_FORBIDEN_ACCESS);
        }
        else if (status == 404) {
            llOwnerSay(_PAGE_NOT_FOUND);
        }
        else if (status != 200 && status != 403 && status != 404) {
            llOwnerSay(_INTERNET_EXPLODED);
        }
        else {
            // get the values
            body = llStringTrim(body , STRING_TRIM);
            list values = llParseStringKeepNulls(body,[HTTP_SEPARATOR],[]);
            string answer = llList2String(values, 0);
            string value = llList2String(values, 1);
            if (request_id == registerTerminalId) {
                if (answer == "success") {
                    llOwnerSay(value);
                    state wait;
                }
                else if (answer == "error") {
                    llOwnerSay(value);
                    llOwnerSay(_SCRIPT_WILL_STOP);
                    return;
                }
            }
        }
    }
}
// ************************
//            WAIT MODE
// ************************
state wait {
    on_rez(integer nbr) {
        llResetScript();
    }
    state_entry() {
        llOwnerSay(_ENTERING_WAIT_MODE);
        llMessageLinked(LINK_THIS, SET_READY, "", NULL_KEY);
        llMessageLinked(LINK_THIS, SET_ENABLED, "", NULL_KEY);
        update_time = llGetUnixTime() + update_speed;
        llSetTimerEvent(1);
    }
    touch_start(integer total_number) {
        key toucher = llDetectedKey(0);
        if (toucher == owner) {
            dialog(owner, _CHOOSE_AN_OPTION, [_RESET, _CLOSE], [_RESET, _CLOSE]);
        }
        else {
            if (busy && toucher != actual_user) {
                llInstantMessage(toucher, _ONLY_ONE_USER_AT_A_TIME);
            }
            else if (busy && toucher == actual_user) {
                llInstantMessage(toucher, _ONLY_ONE_REQUEST_AT_A_TIME);
            }
            else if (!busy || toucher != actual_user) {
                if (llGetListLength(apps_menu) > 0) {
                    actual_user = toucher;
                    llMessageLinked(LINK_THIS, SET_ACTUAL_USER, "", actual_user);
                    callMainMenu(toucher, _CHOOSE_AN_OPTION, []);
                }
            }
        }
    }
    link_message(integer sender_num, integer num, string str, key id) {
        if (num == lnkDialogTimeOut) {
            dialogNotify(id, _MENU_TIMEOUT);
            state default;
        }
        else if (num == lnkDialogResponse) {
            if (str == _RESET) {
                llResetScript();
            }
        }
        else if (num == GET_PARAMS) {
            giveParams();
        }
        else if (num == SET_BUSY) {
            setMessage(SET_BUSY);
            actual_user = id;
            request_time = llGetUnixTime();
        }
        else if (num == SET_ENABLED) {
            setMessage(SET_ENABLED);
            actual_user = NULL_KEY;
            busy = FALSE;
            request_time = 0;
        }
        else if (num == ADD_APP) {
            apps_menu = (apps_menu=[]) + apps_menu + [str];
        }
        else if (num == ENABLE_COUNTDOWN) {
            if (str == "TRUE") {
                countdown = TRUE;
            }
            else {
                countdown = FALSE;
            }
        }
        else if (num == RESET) {
            llResetScript();
        }
    }
    timer() {
        act_time = llGetUnixTime();
        if (countdown) {
            llInstantMessage(actual_user, (string)(busy_time - (act_time - request_time)));
        }
        if (busy && (act_time - request_time) >= busy_time) {
            llMessageLinked(LINK_THIS, SET_ENABLED, "", NULL_KEY);
            countdown = FALSE;
        }
        if (act_time >= update_time) {
            update_time = act_time + update_speed;
            llOpenRemoteDataChannel();
        }
    }
    remote_data(integer type, key channel, key message_id, string sender, integer ival, string sval) {
        if (type & REMOTE_DATA_CHANNEL) {
            rpc_channel = channel;
            updateTerminal();
        }
        else if (type & REMOTE_DATA_REQUEST) {
            list values = llParseString2List(sval, [HTTP_SEPARATOR], []);
            string command = llList2String(values, 0);
            string answer;
            if (command == "check status") {
                answer = "online";
            }
            llRemoteDataReply(channel, message_id, answer, 1);
        }
    }
}