// $Id$
// @version SlUser
// @package SlPoints
// @copyright Copyright wene / ssm2017 Binder (C) 2009. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

// todo : check if no site or no module
// todo : write watchdog entry

// **********************
//          STRINGS
// **********************
// === common ===
string _RESET = "Reset";
string _CLOSE = "Close";
string _MENU_TIMEOUT = "Menu time-out. Please try again.";
string _ADD_MONEY = "Add money";
string _GETTING_POINTS = "Getting points";
string _SETTING_POINTS = "Setting points";
string _REFUNDING = "Refunding";
string _ONLY_ONE_USER_PER_REQUEST_PLEASE = "Only one user per request please";
// === params ===
string _PARSE_PARAMS_ERROR = "Parse params error in about module";
// === http ===
string _REQUEST_TIMED_OUT = "Request timed out";
string _FORBIDEN_ACCESS = "Forbiden access";
string _PAGE_NOT_FOUND = "Page not found";
string _INTERNET_EXPLODED = "the internet exploded!!";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//          VARS
// **********************
string url = "";
string url2 = "";
string password = "";
integer display_info = 1;
integer update_speed = 30;
integer busy_time = 30;
key owner;
integer busy = FALSE;
key actual_user = NULL_KEY;
integer listener;
// separators
string HTTP_SEPARATOR = ";";
string PARAM_SEPARATOR = "||";
// **********************
//          CONSTANTS
// **********************
integer RESET = 20000;
integer ADD_APP = 20001;
integer ENABLE_COUNTDOWN = 20002;
// status
integer SET_READY = 20011;
integer SET_ENABLED = 20012;
integer SET_DISABLED = 20013;
integer SET_BUSY = 20014;
// params
integer SET_PARAMS = 20025;
integer GET_PARAMS = 20026;
// user
integer SET_ACTUAL_USER = 20101;
integer GET_ACTUAL_USER = 20102;
// **********************
//          FUNCTIONS
// **********************
integer parseParams(string params) {
    // url | url2 | display_info | update_speed | busy_time | http_separator
    list values = llParseStringKeepNulls(params, [PARAM_SEPARATOR], []);
    url = llList2String(values, 0);
    url2 = llList2String(values, 1);
    password = llList2String(values, 2);
    display_info = llList2Integer(values, 3);
    update_speed = llList2Integer(values, 4);
    busy_time = llList2Integer(values, 5);
    HTTP_SEPARATOR = llList2String(values, 6);
    if (url != "" && url2 != "") {
        return TRUE;
    }
    return FALSE;
}
// **********************
//          HTTP
// **********************
// get points
key getPointsId;
getPoints(key userKey) {
    if ( display_info ) {
        llOwnerSay(_GETTING_POINTS);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    getPointsId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=slpoints"
                        +"&cmd=getPoints"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // user values
                        +"user_key="+(string)userKey+":"
                        +"user_name="+llKey2Name(userKey));
}
// set points
key setPointsId;
setPoints(integer amount, key userKey) {
    if ( display_info ) {
        llOwnerSay(_SETTING_POINTS);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    setPointsId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=slpoints"
                        +"&cmd=setPoints"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // user values
                        +"amount="+(string)amount+":"
                        +"user_key="+(string)userKey+":"
                        +"user_name="+llKey2Name(userKey));
}
// ********** DIALOG FUNCTIONS **********
// Dialog constants
integer lnkDialog = 14001;
integer lnkDialogNotify = 14004;
integer lnkDialogResponse = 14002;
integer lnkDialogTimeOut = 14003;
integer lnkDialogReshow = 14011;
integer lnkDialogCancel = 14012;
string seperator = "||";
integer dialogTimeOut = 0;
string packDialogMessage(string message, list buttons, list returns){
    string packed_message = message + seperator + (string)dialogTimeOut;
    integer i;
    integer count = llGetListLength(buttons);
    for(i=0; i<count; i++){
        string button = llList2String(buttons, i);
        if(llStringLength(button) > 24) button = llGetSubString(button, 0, 23);
        packed_message += seperator + button + seperator + llList2String(returns, i);
    }
    return packed_message;
}
dialogReshow(){llMessageLinked(LINK_THIS, lnkDialogReshow, "", NULL_KEY);}
dialogCancel(){
    llMessageLinked(LINK_THIS, lnkDialogCancel, "", NULL_KEY);
    llSleep(1);
}
dialog(key id, string message, list buttons, list returns){
    llMessageLinked(LINK_THIS, lnkDialog, packDialogMessage(message, buttons, returns), id);
}
dialogNotify(key id, string message){
    list rows;
    llMessageLinked(LINK_THIS, lnkDialogNotify,
        message + seperator + (string)dialogTimeOut + seperator,
        id);
}
// ********** END DIALOG FUNCTIONS **********
// **********************
//          MAIN ENTRY
// **********************
default {
    state_entry() {
        owner = llGetOwner();
    }
    link_message(integer sender_num, integer num, string str, key id) {
        if (num == SET_READY) {
            state getParams;
        }
        else if (num == RESET) {
            llResetScript();
        }
    }
}
// **********************
//          GET PARAMS
// **********************
state getParams {
    state_entry() {
        llMessageLinked(LINK_THIS, ADD_APP, _ADD_MONEY, NULL_KEY);
        llMessageLinked(LINK_THIS, GET_PARAMS, "", NULL_KEY);
    }
    link_message(integer sender_num, integer num, string str, key id) {
        if (num == SET_PARAMS) {
            if (parseParams(str)) {
                state getPerms;
            }
            else {
                llOwnerSay(_PARSE_PARAMS_ERROR);
            }
        }
        else if (num == RESET) {
            llResetScript();
        }
    }
}
// **********************
//          GET PERMS
// **********************
state getPerms {
    state_entry() {
        llRequestPermissions(llGetOwner(), PERMISSION_DEBIT);
    }
    run_time_permissions(integer perms) {
        if (perms & PERMISSION_DEBIT) {
            state wait;
        }
    }
    link_message(integer sender_num, integer num, string str, key id) {
        if (num == RESET) {
            llResetScript();
        }
    }
}
// ************************
//            WAIT MODE
// ************************
state wait {
    link_message(integer sender_num, integer num, string str, key id) {
        if (num == SET_BUSY) {
            busy = TRUE;
            actual_user = id;
        }
        else if (num == SET_ENABLED) {
            busy = FALSE;
            actual_user = NULL_KEY;
        }
        else if (num == SET_ACTUAL_USER) {
            actual_user = id;
        }
        else if (num == lnkDialogTimeOut) {
            dialogNotify(id, _MENU_TIMEOUT);
            state wait;
        }
        else if (num == lnkDialogResponse) {
            if (str == _RESET) {
                llResetScript();
            }
            else if (str == _ADD_MONEY) {
                llMessageLinked(LINK_THIS, SET_BUSY, "", actual_user);
                state addMoney;
            }
        }
        else if (num == RESET) {
            llResetScript();
        }
    }
}
// ************************
//            ADD MONEY
// ************************
state addMoney {
    money(key giver, integer amount) {
        if (giver == actual_user) {
            setPoints(amount, giver);
        }
        else {
            llInstantMessage(giver, _ONLY_ONE_USER_PER_REQUEST_PLEASE);
            llGiveMoney(giver, amount);
            llInstantMessage(giver, _REFUNDING);
        }
    }
    link_message(integer sender_num, integer num, string str, key id) {
        string cmd = (string)id;
        if (cmd == "setEnabled") {
            busy = FALSE;
            actual_user = NULL_KEY;
            state wait;
        }
        else if (cmd == "reset") {
            llResetScript();
        }
    }
    http_response(key request_id, integer status, list metadata, string body) {
        if (request_id != getPointsId && request_id != setPointsId) {
            return;
        }
        if (status == 499) {
            llOwnerSay(_REQUEST_TIMED_OUT);
        }
        else if (status == 403) {
            llOwnerSay(_FORBIDEN_ACCESS);
        }
        else if (status == 404) {
            llOwnerSay(_PAGE_NOT_FOUND);
        }
        else if (status != 200 && status != 403 && status != 404) {
            llOwnerSay(_INTERNET_EXPLODED);
        }
        else {
            if ( request_id == getPointsId || request_id == setPointsId ) {
                // get the values
                body = llStringTrim( body , STRING_TRIM);
                list values = llParseStringKeepNulls(body,[HTTP_SEPARATOR],[]);
                string answer = llList2String(values, 0);
                string message = llList2String(values, 1);
                string userKey = llList2String(values, 2);
                integer amount = llList2Integer(values, 3);
                if ( answer == "success") {
                    llInstantMessage((key)userKey, message);
                }
                else if ( answer == "error" ) {
                    llInstantMessage((key)userKey, message);
                    llGiveMoney(userKey, amount);
                    llInstantMessage((key)userKey, _REFUNDING);
                }
                llMessageLinked(LINK_THIS, SET_ENABLED, "", actual_user);
                state wait;
            }
        }
    }
}